require 'singleton'
require 'thread'

lock = Mutex.new
lock.synchronize do 

class Plan
  include Singleton
  
  def initialize
    puts "Initializing!!"
	@agentModel = Java::sk.fiit.jim.agent.models.AgentModel.getInstance
    @plan = []
    @queue = []
	@names = []
    @turned = false
	@isStanding = true
	
  end
  
  def control
    if @plan.empty? or @plan[0].ended?
      replan
    end
	unless @plan.empty?
	  @plan[0].execute
    end
  end
  
  def replan
    @plan.clear
    if not @beamed
      @plan << Beam.new
      @beamed = true
      return
    end
	@isStanding = (not @agentModel.isOnGround)
	if @isStanding
      if @queue.empty?
	    fillQueue
	  end
      unless @queue.empty?
	    @plan << @queue.shift
	  end
	else
	  #puts "spadol+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
	  @queue.clear
	  if not @turned
	    @turned = true
		@plan.clear
	    @plan << LowSkill.new("turn_to_back")
		return
	  end
	  if @agentModel.isLyingOnBack
		@plan.clear
	    @plan << LowSkill.new("turn_to_stomach_from_back")
		turned = false
		return
	  end
	  if @agentModel.isLyingOnBelly
		@plan.clear
	    @plan << LowSkill.new("stand_front")
		turned = false
		return
	  end
	end
  end
  
  def reset
    @plan.clear
    @beamed = false
  end
  
  def fillQueue
	@names = Java::sk.fiit.jim.agent.Planner.getPlaned
	unless @names == nil
	  Java::sk.fiit.jim.agent.Planner.clearPlaned
	  #puts "plnime rad mien je #{@names.size}"
	  @names.size.times do |i|
	    @queue << LowSkill.new(@names[i])
	  end
	  #puts "rad ma dlzku #{@queue.size}"
	  end
	return
  end
end

#reset on 2nd load => causing replan
Plan.instance.reset
end