package sk.fiit.jim.agent;

import org.jruby.compiler.ir.operands.Array;

import sk.fiit.jim.Settings;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.agent.moves.LowSkills;
import sk.fiit.jim.agent.skills.FakeHighSkill;
import sk.fiit.jim.agent.skills.HighSkill;
import sk.fiit.jim.init.Script;
import sk.fiit.jim.log.Log;
import sk.fiit.jim.log.LogType;

/**
 *  Planner.java
 *
 *@Title        Jim
 *@author       $Author: marosurbanec $
 */
public class Planner{

	private static final double ENOUGH_TIME_FOR_PHASE = 200.0;
	//5 millisecond = 5,000,000 nanoseconds
	private static final int ENOUGH_TIME = 5*1000*1000;
	static Script planningScript = Script.createScript("Plan.instance.control");
	public static double nextTimePhaseEnds;
	public static long loopStart;
	private static String moveNames[] = {"turn_right2", "turn_left2", "walk3", "goalkeeper"};
	//testovacia premenna
	public static FakeHighSkill hs1 = null;
	private static long count = 0;
	
	public static void proceed(){
		//count = count + 1;
		//System.out.println("Count je "+count);
		
		planningScript.execute();
		if ((count > 1000) && (count < 1300)){
			moveNames = new String[4];
			moveNames[0] = "turn_right2";
			moveNames[1] = "bad_move";
			moveNames[2] = "turn_right2";
			moveNames[3] = "stable_walk_second";
		}
		/*if (hs1 == null){
			hs1 = new FakeHighSkill();
			hs1.skillToChoose = LowSkills.get("turn_right2");
		}
		if (hs1.isEnded()){
			hs1.skillToChoose = LowSkills.get("walk_fine");
		}
		try {
			hs1.execute();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
	}
	public static String[] getPlaned(){
		return moveNames;
	}
	
	public static void setPlaned(String names[]){
		moveNames = names;
	}
	
	public static void clearPlaned(){
		moveNames = null;
	}
	
	public static void runGarbageCollectIfEnoughTime(){
		if (!Settings.getBoolean("runGcOnPhaseStart"))
			return;
		long now = System.nanoTime();
		double serverTime = EnvironmentModel.SIMULATION_TIME;
		Log.debug(LogType.PLANNING, "Loop took %d ms", (now - loopStart));
		//we have enough time to run gc
		if ((now - loopStart) < ENOUGH_TIME && (nextTimePhaseEnds - serverTime) > ENOUGH_TIME_FOR_PHASE){
			Log.debug(LogType.PLANNING, "We have enough time, running GC and finalization");
			runGc();
		}
	}

	private static void runGc(){
		new Thread(new Runnable(){
			public void run(){
				System.runFinalization();
				System.gc();
			}
		}).start();
	}
}
