package sk.fiit.jim.agent.models;

import org.junit.Before;
import org.junit.Test;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.is;

import static org.junit.Assert.assertThat;

import sk.fiit.jim.math.Vector3D;

/**
 *  DynamicObjectTest.java
 *
 *@Title        Jim
 *@Company      Interway s.r.o. (www.interway.sk)
 *@Copyright    Interway s.r.o. (c) 2001-2010
 *@author       $Author: marosurbanec $
 *@version      $Revision: 1.3 $
 *@created      Date: 16.8.2010 12:31:55
 *@modified     $Date: 2004/08/16 06:26:11 $
 */
public class DynamicObjectTest{
	
	private DynamicObject ball;

	@Before
	public void setUp(){
		ball = new DynamicObject();
		ball.setPosition(Vector3D.cartesian(3.0, 3.0, 0), 0.0);
		ball.setPosition(Vector3D.cartesian(2.0, 2.0, 0), 1.0);
	}
	
	@Test
	public void positionPrediction(){
		Vector3D predictedGlobal = ball.predictPositionIn(1.0);
		Vector3D predictedRelative = ball.predictRelativePositionIn(1.0);
		
		assertThat(predictedGlobal, is(equalTo(Vector3D.cartesian(1.0, 1.0, 0))));
		assertThat(predictedRelative, is(equalTo(Vector3D.cartesian(-1.0, 1.0, 0))));
	}
	
	@Test(expected=java.lang.IllegalArgumentException.class)
	public void throwExceptionOnBadArgument(){
		ball.predictPositionIn(-1.0);
	}
}