package sk.fiit.jim.agent.models;

import java.util.HashMap;
import java.util.Map;

import sk.fiit.jim.agent.parsing.ParsedData;
import sk.fiit.jim.agent.parsing.ParsedDataObserver;
import sk.fiit.jim.code_review.Problem;


/**
 *  EnvironmentData.java
 *
 *@Title        Jim
 *@author       $Author: marosurbanec $
 */
@Problem("document!")
public class EnvironmentModel implements ParsedDataObserver{
	
	private static EnvironmentModel instance = new EnvironmentModel();
	
	public static EnvironmentModel getInstance() {
		return instance;
	}
	
	public void processNewServerMessage(ParsedData data) {
		GAME_TIME = data.GAME_TIME;
		SIMULATION_TIME = data.SIMULATION_TIME;
		PLAY_MODE = data.playMode;
	}
	
	public static double TIME_STEP = 0.02d;
	public static double GAME_TIME;
	public static double SIMULATION_TIME;
	public static PlayMode PLAY_MODE;
	public static Version version;
	
	@SuppressWarnings("serial")
	public static enum PlayMode{
		BEFORE_KICK_OFF,
		PLAY_ON,
		KICK_OFF_LEFT,
		KICK_OFF_RIGHT,
		KICK_IN_LEFT,
		KICK_IN_RIGHT,
		CORNER_KICK_LEFT,
		CORNER_KICK_RIGHT,
		GOAL_KICK_LEFT,
		GOAL_KICK_RIGHT,
		OFFSIDE_LEFT,
		OFFSIDE_RIGHT,
		GAME_OVER,
		GOAL_LEFT,
		GOAL_RIGHT,
		FREE_KICK_LEFT,
		FREE_KICK_RIGHT;
		
		private static Map<String, PlayMode> serverNotation = new HashMap<String, PlayMode>(){{
			put("PlayOn", PLAY_ON);
			put("BeforeKickOff", BEFORE_KICK_OFF);
			put("KickOff_Left", KICK_OFF_LEFT);
			put("KickOff_Right", KICK_OFF_RIGHT);
			put("KickIn_Left", KICK_IN_LEFT);
			put("KickIn_Right", KICK_IN_RIGHT);
			put("corner_kick_left", CORNER_KICK_LEFT);
			put("corner_kick_right", CORNER_KICK_RIGHT);
			put("goal_kick_left", GOAL_KICK_LEFT);
			put("goal_kick_right", GOAL_KICK_RIGHT);
			put("offside_left", OFFSIDE_LEFT);
			put("offside_right", OFFSIDE_RIGHT);
			put("GameOver", GAME_OVER);
			put("Goal_Left", GOAL_LEFT);
			put("Goal_Right", GOAL_RIGHT);
			put("free_kick_left", FREE_KICK_LEFT);
			put("free_kick_right", FREE_KICK_RIGHT);
		}};

		public static PlayMode fromString(String group){
			return serverNotation.get(group);
		}
	}
	
	public static enum Version{
		VERSION_0_6_3,
		VERSION_0_6_2;
	}
}