package sk.fiit.jim.agent.moves;

import org.junit.BeforeClass;
import org.junit.Test;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.hamcrest.CoreMatchers.is;

import static org.junit.Assert.assertThat;

import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.init.SkillsFromXmlLoaderTest;

/**
 * LowSkillTest.java
 * 
 * @Title Jim
 * @author $Author: marosurbanec $
 */
public class LowSkillTest {
	
	@BeforeClass
	public static void loadXml() {
		
		SkillsFromXmlLoaderTest.loadXml();
	}

	@Test
	public void activePhase() {
		
		LowSkill testLowSkill = LowSkills.get("walk_straight");
		testLowSkill.carryOn();
		assertThat(testLowSkill.activePhase.name, is(equalTo(testLowSkill.initialPhase)));
	}

	@Test
	public void targetState() {
		
		LowSkill testLowSkill = LowSkills.get("walk_straight");
		testLowSkill.reset();
		testLowSkill.carryOn();
		EnvironmentModel.SIMULATION_TIME = 200.0;
		testLowSkill.carryOn();
		assertThat(testLowSkill.activePhase.name, is(equalTo("walk2")));
	}

	@Test
	public void finalState() {
		
		LowSkill testLowSkill = LowSkills.get("walk_straight");
		testLowSkill.reset();
		testLowSkill.carryOn();
		EnvironmentModel.SIMULATION_TIME = 300.0;
		testLowSkill.carryOn();
		EnvironmentModel.SIMULATION_TIME = 400.0;
		testLowSkill.carryOn();
		assertThat(testLowSkill.activePhase.name, is(equalTo("walk_final")));
	}
}