package sk.fiit.jim.agent.moves;

import java.util.HashMap;
import java.util.Map;

/**
 *  LowSkills.java
 *
 *		Servers as a cache for all low skills found in XMLs in ROOT/moves directory 
 *
 *@Title        Jim
 *@author       $Author: marosurbanec $
 */
public final class LowSkills{
	private LowSkills(){}
	static private Map<String, LowSkill> skills = new HashMap<String, LowSkill>();
	
	public static void addSkill(LowSkill skill){
		if (skill == null){
			return;//TODO analyze why is the parser of skill XML files returning null object after he shouldnt
			//throw new IllegalArgumentException("addSkill argument 1(LowSkill skill) is null");
		}
		
		skills.put(skill.name, skill);
	}
	
	public static boolean exists(String name){
		if (name == null){
			throw new IllegalArgumentException("addSkill argument 1(String name) is null");
		}
		return skills.containsKey(name);
	}
	
	public static LowSkill get(String name){
		if (name == null){
			throw new IllegalArgumentException("get argument 1(String name) is null");
		}
		return skills.get(name);
	}
	
	public static void resetAll(){
		for (LowSkill skill : skills.values()){
			skill.activePhase = null;
		}
	}
}
