package sk.fiit.jim.agent.moves;

import java.util.ArrayList;
import java.util.List;

/**
 *  Phase.java
 *
 *@Title        Jim
 *@author       $Author: marosurbanec $
 */
public class Phase{
	
	public Phase(){}
	
	
	public Phase(String name, double duration){
		if (name == null){
			throw new IllegalArgumentException("LowSkill constructor argument 1(String name) is null");
		}
		this.name = name;
		this.duration = duration;
	}


	public static final Phase EMPTY_PHASE = new Phase(){{
		isFinal = true;
		name = "EMPTY_PHASE";
		next = "EMPTY_PHASE";
		//we can't set 0.0, that would cause ZeroDivisionException 
		duration = 20.0;
		}
	};
	
	public String name;
	public String next;
	public List<EffectorData> effectors = new ArrayList<EffectorData>();
	public double duration = 0.0;
	public String finalizationPhase;
	public boolean isFinal;
	
	@Override
	public String toString(){
		return name;
	}
}