package sk.fiit.jim.agent.parsing;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.agent.models.FixedObject;
import sk.fiit.jim.agent.moves.Joint;
import sk.fiit.jim.math.Vector3D;

/**
 *  ParsedData.java
 *		
 *		POJO holding data parsed from incoming message. Generated by {@link Parser}
 *
 *@Title        Jim
 *@author       $Author: marosurbanec $
 */
public class ParsedData{

	public double SIMULATION_TIME;
	public double GAME_TIME;
	public Integer PLAYER_ID;
	public Boolean OUR_SIDE_IS_LEFT; 
	public EnvironmentModel.PlayMode playMode;
	public Map<Joint, Double> agentsJoints = new HashMap<Joint, Double>();
	public Vector3D gyroscope;
	public Vector3D accelerometer;
	public ForceReceptor forceReceptor;
	
	public Vector3D ballRelativePosition;
	public Map<FixedObject, Vector3D> fixedObjects = new LinkedHashMap<FixedObject, Vector3D>();
	public Map<Integer, List<Vector3D>> opponents = new LinkedHashMap<Integer, List<Vector3D>>();
	public Map<Integer, List<Vector3D>> teammates = new LinkedHashMap<Integer, List<Vector3D>>();

	//added by Peto and Edo
	public Boolean bumper;
	public HearReceptor hearReceptor;

}