package sk.fiit.jim.math;

import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;;

/**
 *  AnglesTest.java
 *
 *@Title        Jim
 *@author       $Author: marosuncik $
 */

public class AnglesTest{
	
	@Test
	public void angleDiff(){
		assertNotNull(Angles.angleDiff(-Math.PI / 3.0, Math.PI / 2.0));
		assertNotNull(Angles.angleDiff(0, 0));
				
		assertEquals(Angles.angleDiff(-Math.PI / 4.0, Math.PI / 4.0), Math.PI / 2.0, .01);
		assertEquals(Angles.angleDiff(Math.PI / 4.0, Math.PI / 8.0), Math.PI / 8.0, .01);
		assertEquals(Angles.angleDiff(Math.PI / 4.0, Math.PI / 4.0), 0.0, .01);
		assertEquals(Angles.angleDiff(0.0, 3*Math.PI), Math.PI, .01);
		assertEquals(Angles.angleDiff(3.0*Math.PI/2.0, -3.0*Math.PI/2.0), Math.PI, .01);
	}
	
	@Test
	public void angleDiffDeg(){
		assertEquals(Angles.angleDiffInDeg(0, 0), 0.0, .01);
		assertEquals(Angles.angleDiffInDeg(90.0, 90.0), 0.0, .01);
		assertEquals(Angles.angleDiffInDeg(90.0, 120.0), 30.0, .01);
		assertEquals(Angles.angleDiffInDeg(120.0, 111.0), 9.0, .01);
		assertEquals(Angles.angleDiffInDeg(1000.0, 900.0), 100.0, .01);
	}
	
	@Test
	public void normalize(){
		assertNotNull(Angles.normalize(0));
		assertNotNull(Angles.normalize(Math.PI));
		assertNotNull(Angles.normalize(3*Math.PI));
		
		assertEquals(Math.PI, Angles.normalize(Math.PI), .01);
		assertEquals(0, Angles.normalize(0), .01);
		assertEquals(Math.PI, Angles.normalize(3*Math.PI), .01);
		assertEquals(Math.PI, Angles.normalize(7*Math.PI), .01);
	}
}