package sk.fiit.jim.math;

/**
 *  KalmanForVector.java
 *
 *@Title        Jim
 *@author       $Author: marosurbanec $
 */
public class KalmanForVector{
	
	KalmanForVariable x;
	KalmanForVariable y;
	KalmanForVariable z;
	
	public KalmanForVector(){
		this(.475, .375);
	}
	
	public KalmanForVector(double q, double r){
		x = new KalmanForVariable(q, r);
		y = new KalmanForVariable(q, r);
		z = new KalmanForVariable(q, r);
	}
	
	
	public Vector3D update(Vector3D observed){
		if (observed == null){
			throw new IllegalArgumentException("getInt argument 1 is null");
		}
		double x = this.x.update(observed.getX());
		double y = this.y.update(observed.getY());
		double z = this.z.update(observed.getZ());
		return Vector3D.cartesian(x, y, z);
	}
}