package sk.fiit.jim.math;

import org.junit.Test;
import static org.junit.Assert.assertEquals;

/**
 *  MathExpressionEvaluatorTest.java
 *
 *@Title        Jim
 *@author       $Author: marosuncik $
 */
public class MathExpressionEvaluatorTest{
	
	@Test
	public void intResult(){
		assertEquals(new MathExpressionEvaluator("0 + 0").getInt(), 0);
		assertEquals(new MathExpressionEvaluator("7 + 5").getInt(), 12);
		assertEquals(new MathExpressionEvaluator("7 - 5").getInt(), 2);
		assertEquals(new MathExpressionEvaluator("7 * 5").getInt(), 35);
		assertEquals(new MathExpressionEvaluator("7 - 7").getInt(), 0);
		assertEquals(new MathExpressionEvaluator("1 - 7").getInt(), -6);
		assertEquals(new MathExpressionEvaluator("100000 - 10").getInt(), 99990);
		assertEquals(new MathExpressionEvaluator("2 * 5 * 5").getInt(), 50);
	}
	
	@Test
	public void doubleResult(){
		assertEquals(new MathExpressionEvaluator("7 + 5").getDouble(), 12.0, 0.1);
		assertEquals(new MathExpressionEvaluator("100000 - 10").getDouble(), 99990.0, 0.1);
		assertEquals(new MathExpressionEvaluator("2.0**0.5").getDouble(), 1.41, 0.01);
		assertEquals(new MathExpressionEvaluator("2 * 5 * 5").getDouble(), 50.0, 0.1);
		assertEquals(new MathExpressionEvaluator("7 - 7").getDouble(), 0.0, 0.1);
		assertEquals(new MathExpressionEvaluator("1 - 7").getDouble(), -6.0, 0.1);
	}
	
	@Test(expected= IllegalArgumentException.class) public void doubleException() { 
		new MathExpressionEvaluator(null).getDouble(); 
	}
	
	@Test(expected= IllegalArgumentException.class) public void intException() { 
		new MathExpressionEvaluator(null).getInt(); 
	}
}